/* This machine-generated file includes source code from GNU Jitter.

   Copyright (C) 2016-2021 Luca Saiu
   Written by Luca Saiu

   GNU Jitter is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation, either version 3 of the License,
   or (at your option) any later version.

   GNU Jitter is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Jitter.  If not, see <http://www.gnu.org/licenses/>.


  Copyright (C) 2022 Luca Saiu
  Copyright (C) 2022 ???
  Written by Luca Saiu and ???

  This file is part of the İzmir example, based on the Jitter
  structured-language example which is distributed along with
  GNU Jitter under its same license.

  IzmirVM is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  IzmirVM is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with IzmirVM.  If not, see <http://www.gnu.org/licenses/>.

*/

/* User-specified code, initial vm1 part: beginning. */

/* User-specified code, initial vm1 part: end */

/* VM library: main VM C file template.

   Copyright (C) 2016, 2017, 2018, 2019, 2020, 2021 Luca Saiu
   Written by Luca Saiu

   This file is part of GNU Jitter.

   GNU Jitter is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNU Jitter is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Jitter.  If not, see <http://www.gnu.org/licenses/>. */


/* Generated file warning.
 * ************************************************************************** */

/* Unless this file is named exactly "vm1.c" , without any prefix, you are
   looking at a machine-generated derived file.  The original source is the vm.c
   template from Jitter, with added code implementing the izmirvm VM. */




/* When we are using Gnulib the standard header files included below will in
   fact be Gnulib replacements; make sure that the Gnulib macros are
   recognised.
   It is in fact possible that  HAVE_CONFIG_H  is defined even in other
   contexts; it should be harmless to include config.h anyway. */
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif // #ifdef HAVE_CONFIG_H

#include <assert.h>
#include <string.h>

#include <jitter/jitter.h>

#if defined (IZMIRVM_PROFILE_SAMPLE)
#include <sys/time.h>
#endif // #if defined (IZMIRVM_PROFILE_SAMPLE)

#include <jitter/jitter-hash.h>
#include <jitter/jitter-instruction.h>
#include <jitter/jitter-mmap.h>
#include <jitter/jitter-mutable-routine.h>
#include <jitter/jitter-print.h>
#include <jitter/jitter-rewrite.h>
#include <jitter/jitter-routine.h>
#include <jitter/jitter-routine-parser.h>
#include <jitter/jitter-specialize.h>
#include <jitter/jitter-defect.h>
#include <jitter/jitter-patch-in.h>

/* I don't need to include <jitter/jitter-executor.h> here, nor to define
   JITTER_THIS_CAN_INCLUDE_JITTER_EXECUTOR_H ; doing so carelessly might
   lead to subtle bugs, that it is better to prevent.
   Of course I can reconsider this decision in the future. */

#include <jitter/jitter-data-locations.h>

#include "izmirvm-vm.h"
//#include "izmirvm-specialized-instructions.h"
//#include "izmirvm-meta-instructions.h"
#include <jitter/jitter-fatal.h>




/* Check requirements for particular features.
 * ************************************************************************** */

/* VM sample-profiling is only supported with GCC.  Do not bother activating it
   with other compilers, when the numbers would turn out to be unreliable in the
   end. */
#if  defined (IZMIRVM_PROFILE_SAMPLE)        \
     && ! defined (JITTER_HAVE_ACTUAL_GCC)
# error "Sample-profiling is only supported with GCC: it requires (machine-independent)"
# error "GNU C extended asm.  It is not worth supporting other compilers if"
# error "the numbers turn out to be unreliable in the end."
#endif

/* Warn about the unreliability of sample-profiling with simple dispatches
   unless one of the complex dispatches is in use. */
#if  defined (IZMIRVM_PROFILE_SAMPLE)                 \
     && ! defined (JITTER_DISPATCH_MINIMAL_THREADING)  \
     && ! defined (JITTER_DISPATCH_NO_THREADING)
# warning "Sample-profiling is unreliable with simple dispatches: the sample"
# warning "incrementation code can be executed at any point in the VM"
# warning "instruction, not necessarily at the same point (the beginning) for"
# warning "every VM instruction."
#endif




/* Machine-generated data structures.
 * ************************************************************************** */

/* Machine-generated data structures defining this VM.  Initializing a static
   struct is problematic, as it requires constant expressions for each field --
   and const pointers don't qualify.  This is why we initialize the struct
   fields below in izmirvm_initialize. */
static struct jitter_vm
the_izmirvm_vm;

struct jitter_vm * const
izmirvm_vm = & the_izmirvm_vm;

struct jitter_list_header * const
izmirvm_states = & the_izmirvm_vm.states;

/* It is convenient to have this initialised at start up, even before calling
   any initialisation function.  This makes it reliable to read this when, for
   example, handling --version . */
static const struct jitter_vm_configuration
izmirvm_vm_the_configuration
  = {
      IZMIRVM_LOWER_CASE_PREFIX /* lower_case_prefix */,
      IZMIRVM_UPPER_CASE_PREFIX /* upper_case_prefix */,
      IZMIRVM_HASH_PREFIX /* hash_prefix */,
      IZMIRVM_MAX_FAST_REGISTER_NO_PER_CLASS
        /* max_fast_register_no_per_class */,
      IZMIRVM_MAX_NONRESIDUAL_LITERAL_NO /* max_nonresidual_literal_no */,
      IZMIRVM_DISPATCH_HUMAN_READABLE /* dispatch_human_readable */,
      /* The instrumentation field can be seen as a bit map.  See the comment
         in jitter/jitter-vm.h . */
      (jitter_vm_instrumentation_none
#if defined (IZMIRVM_PROFILE_COUNT)
       | jitter_vm_instrumentation_count
#endif
#if defined (IZMIRVM_PROFILE_SAMPLE)
       | jitter_vm_instrumentation_sample
#endif
       ) /* instrumentation */
    };

const struct jitter_vm_configuration * const
izmirvm_vm_configuration
  = & izmirvm_vm_the_configuration;




/* Initialization and finalization: internal functions, not for the user.
 * ************************************************************************** */

/* Initialize threads.  This only needs to be called once at initialization, and
   the user doesn't need to bother with it.  Defined along with the executor. */
void
izmirvm_initialize_threads (void);

/* Check that the encodings in enum jitter_specialized_instruction_opcode (as
   used in the specializer) are coherent with machine-generated code.  Making a
   mistake here would introduce subtle bugs, so it's better to be defensive. */
static void
izmirvm_check_specialized_instruction_opcode_once (void)
{
  static bool already_checked = false;
  if (already_checked)
    return;

  assert (((enum jitter_specialized_instruction_opcode)
           izmirvm_specialized_instruction_opcode__eINVALID)
          == jitter_specialized_instruction_opcode_INVALID);
  assert (((enum jitter_specialized_instruction_opcode)
           izmirvm_specialized_instruction_opcode__eBEGINBASICBLOCK)
          == jitter_specialized_instruction_opcode_BEGINBASICBLOCK);
  assert (((enum jitter_specialized_instruction_opcode)
           izmirvm_specialized_instruction_opcode__eEXITVM)
          == jitter_specialized_instruction_opcode_EXITVM);
  assert (((enum jitter_specialized_instruction_opcode)
           izmirvm_specialized_instruction_opcode__eDATALOCATIONS)
          == jitter_specialized_instruction_opcode_DATALOCATIONS);
  assert (((enum jitter_specialized_instruction_opcode)
           izmirvm_specialized_instruction_opcode__eNOP)
          == jitter_specialized_instruction_opcode_NOP);
  assert (((enum jitter_specialized_instruction_opcode)
           izmirvm_specialized_instruction_opcode__eUNREACHABLE0)
          == jitter_specialized_instruction_opcode_UNREACHABLE0);
  assert (((enum jitter_specialized_instruction_opcode)
           izmirvm_specialized_instruction_opcode__eUNREACHABLE1)
          == jitter_specialized_instruction_opcode_UNREACHABLE1);
  assert (((enum jitter_specialized_instruction_opcode)
           izmirvm_specialized_instruction_opcode__ePRETENDTOJUMPANYWHERE)
          == jitter_specialized_instruction_opcode_PRETENDTOJUMPANYWHERE);

  already_checked = true;
}

/* A prototype for a machine-generated function not needing a public
   declaration, only called thru a pointer within struct jitter_vm . */
int
izmirvm_specialize_instruction (struct jitter_mutable_routine *p,
                                 const struct jitter_instruction *ins);

/* Initialize the pointed special-purpose data structure. */
static void
izmirvm_initialize_special_purpose_data
   (volatile struct jitter_special_purpose_state_data *d)
{
  d->pending_notifications = 0;
  jitter_initialize_pending_signal_notifications
     (& d->pending_signal_notifications);

  /* Initialise profiling fields. */
  jitter_profile_runtime_initialize (izmirvm_vm,
                                     (struct jitter_profile_runtime *)
                                     & d->profile_runtime);
}

/* Finalize the pointed special-purpose data structure. */
static void
izmirvm_finalize_special_purpose_data
   (volatile struct jitter_special_purpose_state_data *d)
{
  jitter_finalize_pending_signal_notifications
     (d->pending_signal_notifications);

  jitter_profile_runtime_finalize (izmirvm_vm,
                                   (struct jitter_profile_runtime *)
                                   & d->profile_runtime);
}




/* Check that we link with the correct Jitter library.
 * ************************************************************************** */

/* It is possible to make a mistake at link time, and link a VM compiled with
   some dispatch with the Jitter runtime for a different dispatch.  That
   would cause crashes that is better to prevent.  This is a way to detect such
   mistakes very early, by causing a link-time failure in case of mismatch. */
extern volatile const bool
JITTER_DISPATCH_DEPENDENT_GLOBAL_NAME;




/* Low-level debugging features relying on assembly: data locations.
 * ************************************************************************** */

#if defined (JITTER_HAVE_KNOWN_BINARY_FORMAT) && ! defined (JITTER_DISPATCH_SWITCH)
/* A declaration for data locations, as visible from C.  The global is defined in
   assembly in its own separate section thru the machinery in
   jitter/jitter-sections.h . */
extern const char
JITTER_DATA_LOCATION_NAME(izmirvm) [];
#endif // #if ...

void
izmirvm_dump_data_locations (jitter_print_context output)
{
#ifndef JITTER_DISPATCH_SWITCH
  jitter_dump_data_locations (output, & the_izmirvm_vm);
#else
  jitter_print_char_star (output,
                          "VM data location information unavailable\n");
#endif // #ifndef JITTER_DISPATCH_SWITCH
}




/* Initialization and finalization.
 * ************************************************************************** */

#if defined (JITTER_HAVE_DEFECT_REPLACEMENT)
JITTER_DEFECT_DESCRIPTOR_DECLARATIONS_(izmirvm)

/* This global is defined from C: there is no particular need of doing it in
   assembly.  It is initialised in izmirvm_execute_or_initialize , where C
   labels are visible. */ // FIXME: unless it turns out to be simpler in assembly ...
jitter_int
izmirvm_defect_descriptors_correct_displacement;
#endif // #if defined (JITTER_HAVE_DEFECT_REPLACEMENT)
#if defined (JITTER_HAVE_PATCH_IN)
JITTER_PATCH_IN_DESCRIPTOR_DECLARATIONS_(izmirvm)
#endif // #if defined (JITTER_HAVE_PATCH_IN)

#ifndef JITTER_DISPATCH_SWITCH
/* True iff thread sizes are all non-negative and non-huge.  We refuse to
   disassemble otherwise, and when replication is enabled we refuse to run
   altogether.  See the comment right below. */
static bool
izmirvm_threads_validated = false;
#endif // #ifndef JITTER_DISPATCH_SWITCH

/* Omit izmirvm_validate_thread_sizes_once for switch-dispatching, as threads
   don't exist at all in that case.*/
#ifndef JITTER_DISPATCH_SWITCH
/* Check that VM instruction sizes are all non-negative, and that no thread
   starts before the end of the previous one.  Even one violation of such
   conditions is a symptom that the code has not been compiled with
   -fno-reorder-blocks , which would have disastrous effects with replication.
   It's better to validate threads at startup and fail immediately than to crash
   at run time.

   If even one thread appears to be wrong then refuse to disassemble when
   replication is disabled, and refuse to run altogether if replication is
   enabled. */
static void
izmirvm_validate_threads_once (void)
{
  /* Return if this is not the first time we got here. */
  static bool already_validated = false;
  if (already_validated)
    return;

#ifdef JITTER_REPLICATE
# define JITTER_FAIL(error_text)                                             \
    do                                                                       \
      {                                                                      \
        fprintf (stderr,                                                     \
                 "About specialized instruction %i (%s) at %p, size %liB\n", \
                 i, izmirvm_specialized_instruction_names [i],              \
                 izmirvm_threads [i],                                       \
                 izmirvm_thread_sizes [i]);                                 \
        jitter_fatal ("%s: you are not compiling with -fno-reorder-blocks",  \
                      error_text);                                           \
      }                                                                      \
    while (false)
#else
# define JITTER_FAIL(ignored_error_text)  \
    do                                    \
      {                                   \
        everything_valid = false;         \
        goto out;                         \
      }                                   \
    while (false)
#endif // #ifdef JITTER_REPLICATE

  /* The minimum address the next instruction code has to start at.

     This relies on NULL being zero, or in general lower in magnitude than any
     valid pointer.  It is not worth the trouble to be pedantic, as this will be
     true on every architecture where I can afford low-level tricks. */
  jitter_thread lower_bound = NULL;

  /* Check every thread.  We rely on the order here, following specialized
     instruction opcodes. */
  int i;
  bool everything_valid = true;
  for (i = 0; i < IZMIRVM_SPECIALIZED_INSTRUCTION_NO; i ++)
    {
      jitter_thread thread = izmirvm_threads [i];
      long size = izmirvm_thread_sizes [i];

      /* Check that the current thread has non-negative non-huge size and
         doesn't start before the end of the previous one.  If this is true for
         all threads we can conclude that they are non-overlapping as well. */
      if (__builtin_expect (size < 0, false))
        JITTER_FAIL("a specialized instruction has negative code size");
      if (__builtin_expect (size > (1 << 24), false))
        JITTER_FAIL("a specialized instruction has huge code size");
      if (__builtin_expect (lower_bound > thread, false))
        JITTER_FAIL("non-sequential thread");

      /* The next thread cannot start before the end of the current one. */
      lower_bound = ((char*) thread) + size;
    }

#undef JITTER_FAIL

#ifndef JITTER_REPLICATE
 out:
#endif // #ifndef JITTER_REPLICATE

  /* If we have validated every thread size then disassembling appears safe. */
  if (everything_valid)
    izmirvm_threads_validated = true;

  /* We have checked the thread sizes, once and for all.  If this function gets
     called again, thru a second izmirvm initialization, it will immediately
     return. */
  already_validated = true;
}
#endif // #ifndef JITTER_DISPATCH_SWITCH

#if defined (JITTER_HAVE_DEFECT_REPLACEMENT)
/* The actual replacement table.  We only need it when defect replacement is in
   use. */
jitter_uint
izmirvm_replacement_table [IZMIRVM_SPECIALIZED_INSTRUCTION_NO];

/* The defective-instruction array for this VM.  The first
   defective_specialized_instruction_no elements of the array contain the
   specialized_instruction_ids of defective instructions; the remaining elements
   are set to -1.  This is initialised by jitter_fill_replacement_table . */
jitter_int
izmirvm_defective_specialized_instructions [IZMIRVM_SPECIALIZED_INSTRUCTION_NO];
#endif // #if defined (JITTER_HAVE_DEFECT_REPLACEMENT)

void
izmirvm_initialize (void)
{
  /* Check that the Jitter library we linked is the right one.  This check
     actually only useful to force the global to be used.  I prefer not to use
     an assert, because assertions can be disabled. */
  if (! JITTER_DISPATCH_DEPENDENT_GLOBAL_NAME)
    jitter_fatal ("impossible to reach: the thing should fail at link time");

#ifdef JITTER_REPLICATE
  /* Initialize the executable-memory subsystem. */
  jitter_initialize_executable ();
#endif // #ifdef JITTER_REPLICATE

  /* Initialise the print-context machinery. */
  jitter_print_initialize ();

  /* Perform some sanity checks which only need to be run once. */
  izmirvm_check_specialized_instruction_opcode_once ();

  /* We have to initialize threads before izmirvm_threads , since the struct
     needs threads. */
  izmirvm_initialize_threads ();

#ifndef JITTER_DISPATCH_SWITCH
  /* Validate threads, to make sure the generated code was not compiled with
     incorrect options.  This only needs to be done once. */
  izmirvm_validate_threads_once ();
#endif // ifndef JITTER_DISPATCH_SWITCH

  /* Initialize the object pointed by izmirvm_vm (see the comment above as to
     why we do it here).  Before actually setting the fields to valid data, fill
     the whole struct with a -- hopefully -- invalid pattern, just to catch
     bugs. */
  static bool vm_struct_initialized = false;
  if (! vm_struct_initialized)
    {
      memset (& the_izmirvm_vm, 0xff, sizeof (struct jitter_vm));

      /* Make the configuration struct reachable from the VM struct. */
      the_izmirvm_vm.configuration = izmirvm_vm_configuration;
      //izmirvm_print_vm_configuration (stdout, & the_izmirvm_vm.configuration);

      /* Initialize meta-instruction pointers for implicit instructions.
         VM-independent program specialization relies on those, so they have to
         be accessible to the Jitter library, out of generated code.  Since
         meta-instructions are sorted alphabetically in the array, the index
         is not fixed. */
      the_izmirvm_vm.exitvm_meta_instruction
        = (izmirvm_meta_instructions + izmirvm_meta_instruction_id_exitvm);
      the_izmirvm_vm.unreachable_meta_instruction
        = (izmirvm_meta_instructions
           + izmirvm_meta_instruction_id_unreachable);

      /* Threads or pointers to native code blocks of course don't exist with
         switch-dispatching. */
#ifndef JITTER_DISPATCH_SWITCH
      the_izmirvm_vm.threads = (jitter_thread *)izmirvm_threads;
      the_izmirvm_vm.thread_sizes = (long *) izmirvm_thread_sizes;
      the_izmirvm_vm.threads_validated = izmirvm_threads_validated;
#if defined (JITTER_HAVE_KNOWN_BINARY_FORMAT)
      the_izmirvm_vm.data_locations = JITTER_DATA_LOCATION_NAME(izmirvm);
#else
      the_izmirvm_vm.data_locations = NULL;
#endif // #if defined (JITTER_HAVE_KNOWN_BINARY_FORMAT)
#endif // #ifndef JITTER_DISPATCH_SWITCH

      the_izmirvm_vm.specialized_instruction_residual_arities
        = izmirvm_specialized_instruction_residual_arities;
      the_izmirvm_vm.specialized_instruction_label_bitmasks
        = izmirvm_specialized_instruction_label_bitmasks;

      /* FIXME: I might want to conditionalize this. */
      the_izmirvm_vm.specialized_instruction_relocatables
        = izmirvm_specialized_instruction_relocatables;

      the_izmirvm_vm.specialized_instruction_callers
        = izmirvm_specialized_instruction_callers;
      the_izmirvm_vm.specialized_instruction_callees
        = izmirvm_specialized_instruction_callees;

      the_izmirvm_vm.specialized_instruction_names
        = izmirvm_specialized_instruction_names;
      the_izmirvm_vm.specialized_instruction_no
        = IZMIRVM_SPECIALIZED_INSTRUCTION_NO;

      the_izmirvm_vm.meta_instruction_string_hash
        = & izmirvm_meta_instruction_hash;
      the_izmirvm_vm.meta_instructions
        = (struct jitter_meta_instruction *) izmirvm_meta_instructions;
      the_izmirvm_vm.meta_instruction_no = IZMIRVM_META_INSTRUCTION_NO;
      the_izmirvm_vm.max_meta_instruction_name_length
        = IZMIRVM_MAX_META_INSTRUCTION_NAME_LENGTH;
      the_izmirvm_vm.specialized_instruction_to_unspecialized_instruction
        = izmirvm_specialized_instruction_to_unspecialized_instruction;
      the_izmirvm_vm.register_class_character_to_register_class
        = izmirvm_register_class_character_to_register_class;
      the_izmirvm_vm.specialize_instruction = izmirvm_specialize_instruction;
      the_izmirvm_vm.rewrite = izmirvm_rewrite;

#if defined (JITTER_HAVE_DEFECT_REPLACEMENT)
      /* Fill the replacement table.  Since the array in question is a global
         with a fixed size, this needs to be done only once. */
      jitter_fill_replacement_table
         (izmirvm_replacement_table,
          izmirvm_defective_specialized_instructions,
          & the_izmirvm_vm,
          izmirvm_worst_case_replacement_table,
          izmirvm_call_related_specialized_instruction_ids,
          izmirvm_call_related_specialized_instruction_id_no,
          izmirvm_specialized_instruction_call_relateds,
          JITTER_DEFECT_DESCRIPTORS_NAME (izmirvm),
          (JITTER_DEFECT_DESCRIPTORS_SIZE_IN_BYTES_NAME (izmirvm)
           / sizeof (struct jitter_defect_descriptor)),
          JITTER_DEFECT_CORRECT_DISPLACEMENT_NAME (izmirvm));
      the_izmirvm_vm.replacement_table = izmirvm_replacement_table;
      the_izmirvm_vm.defective_specialized_instructions
        = izmirvm_defective_specialized_instructions;
      the_izmirvm_vm.specialized_instruction_call_relateds
        = izmirvm_specialized_instruction_call_relateds;
#else /* no defect replacement */
      /* In this configuration it is impossible to have defects: set every
         defect count to zero. */
      the_izmirvm_vm.defect_no = 0;
      the_izmirvm_vm.defective_specialized_instruction_no = 0;
      the_izmirvm_vm.defective_call_related_specialized_instruction_no = 0;
      the_izmirvm_vm.replacement_specialized_instruction_no = 0;
      the_izmirvm_vm.replacement_table = NULL;
      the_izmirvm_vm.defective_specialized_instructions = NULL;
      the_izmirvm_vm.specialized_instruction_call_relateds = NULL;
#endif // #if defined (JITTER_HAVE_DEFECT_REPLACEMENT)

      /* Initialize the empty list of states. */
      JITTER_LIST_INITIALIZE_HEADER (& the_izmirvm_vm.states);

      vm_struct_initialized = true;
    }

#ifdef JITTER_HAVE_PATCH_IN
    /* Since the patch-in table is destroyed at finalisation time we have to
       rebuild it at every initialisation, out of the previous conditional. */
    the_izmirvm_vm.specialized_instruction_fast_label_bitmasks
      = izmirvm_specialized_instruction_fast_label_bitmasks;
    the_izmirvm_vm.patch_in_descriptors =
      JITTER_PATCH_IN_DESCRIPTORS_NAME(izmirvm);
    const size_t patch_in_descriptor_size
      = sizeof (struct jitter_patch_in_descriptor);
    the_izmirvm_vm.patch_in_descriptor_no
      = (JITTER_PATCH_IN_DESCRIPTORS_SIZE_IN_BYTES_NAME(izmirvm)
         / patch_in_descriptor_size);
    /* Cheap sanity check: if the size in bytes is not a multiple of
       the element size, we are doing something very wrong. */
    if (JITTER_PATCH_IN_DESCRIPTORS_SIZE_IN_BYTES_NAME(izmirvm)
        % patch_in_descriptor_size != 0)
      jitter_fatal ("patch-in descriptors total size %li not a multiple "
                    "of the element size %li",
                    (long) (JITTER_PATCH_IN_DESCRIPTORS_SIZE_IN_BYTES_NAME
                            (izmirvm)),
                    (long) patch_in_descriptor_size);
    /* Initialize the patch-in table for this VM. */
    the_izmirvm_vm.patch_in_table
      = jitter_make_patch_in_table (the_izmirvm_vm.patch_in_descriptors,
                                    the_izmirvm_vm.patch_in_descriptor_no,
                                    IZMIRVM_SPECIALIZED_INSTRUCTION_NO);
#else
    the_izmirvm_vm.specialized_instruction_fast_label_bitmasks = NULL;
#endif // #ifdef JITTER_HAVE_PATCH_IN

  jitter_initialize_meta_instructions (& izmirvm_meta_instruction_hash,
                                         izmirvm_meta_instructions,
                                         IZMIRVM_META_INSTRUCTION_NO);

#if defined (JITTER_HAVE_DEFECT_REPLACEMENT)
# if 0
  jitter_dump_replacement_table (stderr, izmirvm_replacement_table,
                                 & the_izmirvm_vm);
  jitter_dump_defects (stderr, izmirvm_defective_specialized_instructions,
                       & the_izmirvm_vm,
                       izmirvm_specialized_instruction_call_relateds);
# endif
#endif // #if defined (JITTER_HAVE_DEFECT_REPLACEMENT)
#if defined (JITTER_HAVE_PATCH_IN)
  //printf ("======================= Patch-in descriptors: BEGIN\n");
  //JITTER_DUMP_PATCH_IN_DESCRIPTORS(izmirvm);
  //printf ("======================= Patch-in descriptors: END\n");
#endif // #if defined (JITTER_HAVE_PATCH_IN)
}

void
izmirvm_finalize (void)
{
  /* There's no need to touch the_izmirvm_vm ; we can keep it as it is, as it
     contains no dynamically-allocated fields. */
  /* Threads need no finalization. */
  jitter_finalize_meta_instructions (& izmirvm_meta_instruction_hash);

#ifdef JITTER_HAVE_PATCH_IN
  /* Destroy the patch-in table for this VM. */
  jitter_destroy_patch_in_table (the_izmirvm_vm.patch_in_table,
                                 IZMIRVM_SPECIALIZED_INSTRUCTION_NO);
#endif // #ifdef JITTER_HAVE_PATCH_IN

#ifdef JITTER_REPLICATE
  /* Finalize the executable-memory subsystem. */
  jitter_finalize_executable ();
#endif // #ifdef JITTER_REPLICATE

  /* Finalize the state list.  If it is not empty then something has gone
     wrong earlier. */
  if (the_izmirvm_vm.states.first != NULL
      || the_izmirvm_vm.states.last != NULL)
    jitter_fatal ("not every state structure was destroyed before IZMIRVM "
                  "finalisation.");
}




/* VM-dependant mutable routine initialization.
 * ************************************************************************** */

struct jitter_mutable_routine*
izmirvm_make_mutable_routine (void)
{
  return jitter_make_mutable_routine (izmirvm_vm);
}




/* Sample profiling: internal API.
 * ************************************************************************** */

#if defined (IZMIRVM_PROFILE_SAMPLE)

/* Sample profiling depends on some system features: fail immediately if they
   are not available */
#if ! defined (JITTER_HAVE_SIGACTION) || ! defined (JITTER_HAVE_SETITIMER)
# jitter_fatal "sample-profiling depends on sigaction and setitimer"
#endif

static struct itimerval
izmirvm_timer_interval;

static struct itimerval
izmirvm_timer_disabled_interval;

/* The sampling data, currently global.  The current implementation does not
   play well with threads, but it can be changed later keeping the same user
   API. */
struct izmirvm_sample_profile_state
{
  /* The state currently sample-profiling.  Since such a state can be only one
     right now this field is useful for printing error messages in case the user
     sets up sample-profiling from two states at the same time by mistake.
     This field is also useful for temporarily suspending and then reenabling
     sampling, when The Array is being resized: if the signal handler sees that
     this field is NULL it will not touch the fields. */
  struct izmirvm_state *state_p;

  /* A pointer to the counts field within the sample_profile_runtime struct. */
  uint32_t *counts;

  /* A pointer to the current specialised instruction opcode within the
     sample_profile_runtime struct. */
  volatile jitter_int * specialized_opcode_p;

  /* A pointer to the field counting the number of samples, again within the
     sample_profile_runtime struct. */
  unsigned int *sample_no_p;
};

/* The (currently) one and only global state for sample-profiling. */
static struct izmirvm_sample_profile_state
izmirvm_sample_profile_state;

static void
izmirvm_sigprof_handler (int signal)
{
#if 0
  assert (izmirvm_sample_profile_state.state_p != NULL);
#endif

  jitter_int specialized_opcode
    = * izmirvm_sample_profile_state.specialized_opcode_p;
  if (__builtin_expect ((specialized_opcode >= 0
                         && (specialized_opcode
                             < IZMIRVM_SPECIALIZED_INSTRUCTION_NO)),
                        true))
    izmirvm_sample_profile_state.counts [specialized_opcode] ++;

  (* izmirvm_sample_profile_state.sample_no_p) ++;
}

void
izmirvm_profile_sample_initialize (void)
{
  /* Perform a sanity check over the sampling period. */
  if (JITTER_PROFILE_SAMPLE_PERIOD_IN_MILLISECONDS <= 0 ||
      JITTER_PROFILE_SAMPLE_PERIOD_IN_MILLISECONDS >= 1000)
    jitter_fatal ("invalid JITTER_PROFILE_SAMPLE_PERIOD_IN_MILLISECONDS: %f",
                  (double) JITTER_PROFILE_SAMPLE_PERIOD_IN_MILLISECONDS);
  struct sigaction action;
  sigaction (SIGPROF, NULL, & action);
  action.sa_handler = izmirvm_sigprof_handler;
  sigaction (SIGPROF, & action, NULL);

  long microseconds
    = (long) (JITTER_PROFILE_SAMPLE_PERIOD_IN_MILLISECONDS * 1000);
  izmirvm_timer_interval.it_interval.tv_sec = 0;
  izmirvm_timer_interval.it_interval.tv_usec = microseconds;
  izmirvm_timer_interval.it_value = izmirvm_timer_interval.it_interval;

  izmirvm_sample_profile_state.state_p = NULL;
  izmirvm_timer_disabled_interval.it_interval.tv_sec = 0;
  izmirvm_timer_disabled_interval.it_interval.tv_usec = 0;
  izmirvm_timer_disabled_interval.it_value
    = izmirvm_timer_disabled_interval.it_interval;
}

void
izmirvm_profile_sample_start (struct izmirvm_state *state_p)
{
  struct jitter_sample_profile_runtime *spr
    = ((struct jitter_sample_profile_runtime *)
       & IZMIRVM_STATE_TO_SPECIAL_PURPOSE_STATE_DATA (state_p)
           ->profile_runtime.sample_profile_runtime);

  if (izmirvm_sample_profile_state.state_p != NULL)
    {
      if (state_p != izmirvm_sample_profile_state.state_p)
        jitter_fatal ("currently it is only possible to sample-profile from "
                      "one state at the time: trying to sample-profile from "
                      "the state %p when already sample-profiling from the "
                      "state %p",
                      state_p, izmirvm_sample_profile_state.state_p);
      else
        {
          /* This situation is a symptom of a bug, but does not need to lead
             to a fatal error. */
          printf ("WARNING: starting profile on the state %p when profiling "
                  "was already active in the same state.\n"
                  "Did you call longjmp from VM code?", state_p);
          fflush (stdout);
        }
    }
  izmirvm_sample_profile_state.state_p = state_p;
  izmirvm_sample_profile_state.sample_no_p = & spr->sample_no;
  izmirvm_sample_profile_state.counts = spr->counts;
  izmirvm_sample_profile_state.specialized_opcode_p
    = & spr->current_specialized_instruction_opcode;
  //fprintf (stderr, "SAMPLE START\n"); fflush (NULL);
  if (setitimer (ITIMER_PROF, & izmirvm_timer_interval, NULL) != 0)
    jitter_fatal ("setitimer failed when establishing a timer");
}

void
izmirvm_profile_sample_stop (void)
{
  if (setitimer (ITIMER_PROF, & izmirvm_timer_disabled_interval, NULL) != 0)
    jitter_fatal ("setitimer failed when disabling a timer");

  izmirvm_sample_profile_state.state_p = NULL;

  /* The rest is just for defenisveness' sake. */
  * izmirvm_sample_profile_state.specialized_opcode_p = -1;
  izmirvm_sample_profile_state.sample_no_p = NULL;
  izmirvm_sample_profile_state.counts = NULL;
  izmirvm_sample_profile_state.specialized_opcode_p = NULL;
}
#endif // #if defined (IZMIRVM_PROFILE_SAMPLE)




/* Slow register initialisation.
 * ************************************************************************** */

/* Initialise slow registers (for register classes defining an initial value) in
   a given Array, starting from a given rank up to another given rank.  The
   argument old_slow_register_no_per_class indicates the number of already
   initialised ranks, which this functions does not touch;
   new_slow_register_no_per_class indicates the new number of ranks.  Every rank
   from old_slow_register_no_per_class + 1 to new_slow_register_no_per_class,
   both included, will be initialised. */
static void
izmirvm_initialize_slow_registers (char *initial_array_pointer,
                                    jitter_int old_slow_register_no_per_class,
                                    jitter_int new_slow_register_no_per_class)
{
  /* Compute the address of the first slow registers, which is the beginning
     of the first rank. */
  union izmirvm_any_register *first_slow_register
    = ((union izmirvm_any_register *)
       ((char *) initial_array_pointer
        + IZMIRVM_FIRST_SLOW_REGISTER_UNBIASED_OFFSET));

  /* Initialise every *new* rank, without touching the old ones. */
  jitter_int i;
  for (i = old_slow_register_no_per_class;
       i < new_slow_register_no_per_class;
       i ++)
    {
      /* A pointer to the i-th rank of slow registers.  Every register
         in the rank is new and in general (according to its class) may
         need initialisation. */
      union izmirvm_any_register *rank
        = first_slow_register + (i * IZMIRVM_REGISTER_CLASS_NO);
      IZMIRVM_INITIALIZE_SLOW_REGISTER_RANK (rank);
    }
#if 0
      fprintf (stderr, "initialised %li (up from %li) slow registers per class, array at %p\n",
               (long) new_slow_register_no_per_class,
               (long) old_slow_register_no_per_class,
               initial_array_pointer);
#endif
}




/* Array re-allocation.
 * ************************************************************************** */

char *
izmirvm_make_place_for_slow_registers (struct izmirvm_state *s,
                                        jitter_int new_slow_register_no_per_class)
{
  if (new_slow_register_no_per_class < 0)
    jitter_fatal ("izmirvm_make_place_for_slow_registers: negative slow "
                  "register number");
  jitter_int old_slow_register_no_per_class
    = s->izmirvm_state_backing.jitter_slow_register_no_per_class;
  /* Change nothing if we already have enough space for the required number of
     slow registers.  The no-change case will be the most common one, and
     this function might be worth optimizing. */
  if (__builtin_expect (new_slow_register_no_per_class
                        > old_slow_register_no_per_class,
                        false))
    {
#if defined (IZMIRVM_PROFILE_SAMPLE)
      /* If sample-profiling is currently in progress on this state suspend it
         temporarily. */
      bool suspending_sample_profiling
        = (izmirvm_sample_profile_state.state_p == s);
      if (suspending_sample_profiling)
        izmirvm_profile_sample_stop ();
#endif // #if defined (IZMIRVM_PROFILE_SAMPLE)

#if 0
      printf ("Increasing slow register-no (per class) from %li to %li\n", (long) old_slow_register_no_per_class, (long)new_slow_register_no_per_class);
      printf ("Array size %li -> %li\n", (long) IZMIRVM_ARRAY_SIZE(old_slow_register_no_per_class), (long) IZMIRVM_ARRAY_SIZE(new_slow_register_no_per_class));
#endif
      /* Save the new value for new_slow_register_no_per_class in the state
         structure; reallocate The Array. */
      s->izmirvm_state_backing.jitter_slow_register_no_per_class
        = new_slow_register_no_per_class;
      s->izmirvm_state_backing.jitter_array
        = jitter_xrealloc ((void *) s->izmirvm_state_backing.jitter_array,
                           IZMIRVM_ARRAY_SIZE(new_slow_register_no_per_class));

     /* Initialise the slow registers we have just added, for every class. */
     izmirvm_initialize_slow_registers (s->izmirvm_state_backing.jitter_array,
                                         old_slow_register_no_per_class,
                                         new_slow_register_no_per_class);

#if defined (IZMIRVM_PROFILE_SAMPLE)
      /* Now we can resume sample-profiling on this state if we suspended it. */
      if (suspending_sample_profiling)
        izmirvm_profile_sample_start (s);
#endif // #if defined (IZMIRVM_PROFILE_SAMPLE)
#if 0
      fprintf (stderr, "slow registers are now %li per class, Array at %p (biased %p)\n",
               ((long)
                s->izmirvm_state_backing.jitter_slow_register_no_per_class),
               s->izmirvm_state_backing.jitter_array,
               s->izmirvm_state_backing.jitter_array + JITTER_ARRAY_BIAS);
#endif
    }

  /* Return the new (or unchanged) base, by simply adding the bias to the
     Array as it is now. */
  return s->izmirvm_state_backing.jitter_array + JITTER_ARRAY_BIAS;
}

void
izmirvm_ensure_enough_slow_registers_for_executable_routine
   (const struct jitter_executable_routine *er, struct izmirvm_state *s)
{
  izmirvm_make_place_for_slow_registers (s, er->slow_register_per_class_no);
}




/* Program text frontend.
 * ************************************************************************** */

void
izmirvm_parse_mutable_routine_from_file_star (FILE *input_file,
                                               struct jitter_mutable_routine *p)
{
  jitter_parse_mutable_routine_from_file_star (input_file, p, izmirvm_vm);
}

void
izmirvm_parse_mutable_routine_from_file (const char *input_file_name,
                                          struct jitter_mutable_routine *p)
{
  jitter_parse_mutable_routine_from_file (input_file_name, p, izmirvm_vm);
}

void
izmirvm_parse_mutable_routine_from_string (const char *string,
                                            struct jitter_mutable_routine *p)
{
  jitter_parse_mutable_routine_from_string (string, p, izmirvm_vm);
}




/* State making and destroying.
 * ************************************************************************** */

/* State initialisation (with a given number of slow registers), reset and
   finalisation are machine-generated. */

void
izmirvm_state_initialize (struct izmirvm_state *sp)
{
  izmirvm_state_initialize_with_slow_registers (sp, 0);
}

struct izmirvm_state *
izmirvm_state_make_with_slow_registers (jitter_uint slow_register_no_per_class)
{
  struct izmirvm_state *res = jitter_xmalloc (sizeof (struct izmirvm_state));
  izmirvm_state_initialize_with_slow_registers (res,
                                                 slow_register_no_per_class);
  return res;
}

struct izmirvm_state *
izmirvm_state_make (void)
{
  return izmirvm_state_make_with_slow_registers (0);
}

void
izmirvm_state_destroy (struct izmirvm_state *state)
{
  izmirvm_state_finalize (state);
  free (state);
}




/* Executing code: unified routine API.
 * ************************************************************************** */

void
izmirvm_ensure_enough_slow_registers_for_routine
   (jitter_routine r, struct izmirvm_state *s)
{
  struct jitter_executable_routine *e
    = jitter_routine_make_executable_if_needed (r);
  izmirvm_ensure_enough_slow_registers_for_executable_routine (e, s);
}

enum izmirvm_exit_status
izmirvm_execute_routine (jitter_routine r,
                          struct izmirvm_state *s)
{
  struct jitter_executable_routine *e
    = jitter_routine_make_executable_if_needed (r);
  return izmirvm_execute_executable_routine (e, s);
}





/* Defects and replacements: user API.
 * ************************************************************************** */

/* These functions are all trivial wrappers around the functionality declared
   in jitter/jitter-defect.h, hiding the VM pointer. */

void
izmirvm_defect_print_summary (jitter_print_context cx)
{
  jitter_defect_print_summary (cx, izmirvm_vm);
}

void
izmirvm_defect_print (jitter_print_context cx,
                       unsigned indentation_column_no)
{
  jitter_defect_print (cx, izmirvm_vm, indentation_column_no);
}

void
izmirvm_defect_print_replacement_table (jitter_print_context cx,
                                         unsigned indentation_column_no)
{
  jitter_defect_print_replacement_table (cx, izmirvm_vm, indentation_column_no);
}




/* Profiling: user API.
 * ************************************************************************** */

/* These functions are all trivial wrappers around the functionality declared
   in jitter/jitter-profile.h, hiding the VM pointer. */

struct izmirvm_profile_runtime *
izmirvm_state_profile_runtime (struct izmirvm_state *s)
{
  volatile struct jitter_special_purpose_state_data *spd
    = IZMIRVM_ARRAY_TO_SPECIAL_PURPOSE_STATE_DATA
        (s->izmirvm_state_backing.jitter_array);
  return (struct izmirvm_profile_runtime *) & spd->profile_runtime;
}

struct izmirvm_profile_runtime *
izmirvm_profile_runtime_make (void)
{
  return jitter_profile_runtime_make (izmirvm_vm);
}

void
izmirvm_profile_runtime_destroy (struct izmirvm_profile_runtime *p)
{
  jitter_profile_runtime_destroy (izmirvm_vm, p);
}

void
izmirvm_profile_runtime_clear (struct izmirvm_profile_runtime * p)
{
  jitter_profile_runtime_clear (izmirvm_vm, p);
}

void
izmirvm_profile_runtime_merge_from (struct izmirvm_profile_runtime *to,
                                     const struct izmirvm_profile_runtime *from)
{
  jitter_profile_runtime_merge_from (izmirvm_vm, to, from);
}

void
izmirvm_profile_runtime_merge_from_state (struct izmirvm_profile_runtime *to,
                                           const struct izmirvm_state *from_state)
{
  const struct izmirvm_profile_runtime* from
    = izmirvm_state_profile_runtime ((struct izmirvm_state *) from_state);
  jitter_profile_runtime_merge_from (izmirvm_vm, to, from);
}

void
izmirvm_profile_runtime_print_unspecialized
   (jitter_print_context ct,
    const struct izmirvm_profile_runtime *p)
{
  jitter_profile_runtime_print_unspecialized (ct, izmirvm_vm, p);
}

void
izmirvm_profile_runtime_print_specialized (jitter_print_context ct,
                                            const struct izmirvm_profile_runtime
                                            *p)
{
  jitter_profile_runtime_print_specialized (ct, izmirvm_vm, p);
}

struct izmirvm_profile *
izmirvm_profile_unspecialized_from_runtime
   (const struct izmirvm_profile_runtime *p)
{
  return jitter_profile_unspecialized_from_runtime (izmirvm_vm, p);
}

struct izmirvm_profile *
izmirvm_profile_specialized_from_runtime (const struct izmirvm_profile_runtime
                                           *p)
{
  return jitter_profile_specialized_from_runtime (izmirvm_vm, p);
}




/* Evrything following this point is machine-generated.
 * ************************************************************************** */

/* What follows could be conceptually split into several generated C files, but
   having too many of them would be inconvenient for the user to compile and
   link.  For this reason we currently generate just three files: one is this,
   which also contains the specializer, another is for the executor, and then a
   header -- a main module is optional.  The executor will be potentially very
   large, so it is best compiled separately.  The specializer might be large as
   well at this stage, even if its compilation is usually much less
   expensive. */
/* These two macros are convenient for making VM-specific identifiers
   using VM-independent macros from a public header, without polluting
   the global namespace. */
#define JITTER_VM_PREFIX_LOWER_CASE izmirvm
#define JITTER_VM_PREFIX_UPPER_CASE IZMIRVM

/* User-specified code, printer part: beginning. */

/* User-specified code, printer part: end */

//#include <stdbool.h>

//#include <jitter/jitter.h>
//#include <jitter/jitter-instruction.h>

//#include "izmirvm-meta-instructions.h"

// FIXME: comment.
struct jitter_hash_table
izmirvm_meta_instruction_hash;



const struct jitter_meta_instruction
izmirvm_meta_instructions [IZMIRVM_META_INSTRUCTION_NO]
  = {
      { 0, "exitvm", 0, true, false, false, true /* this ignores replacements */, NULL },
      { 1, "unreachable", 0, true, false, false, true /* this ignores replacements */, NULL }
    };


/* A pointer to every existing register class descriptor. */
const struct jitter_register_class * const
izmirvm_regiter_classes []
  = {
    };

const struct jitter_register_class *
izmirvm_register_class_character_to_register_class (char c)
{
  switch (c)
    {
    default:  return NULL;
    }
}

//#include "izmirvm-specialized-instructions.h"

const char * const
izmirvm_specialized_instruction_names [IZMIRVM_SPECIALIZED_INSTRUCTION_NO]
  = {
      "!INVALID",
      "!BEGINBASICBLOCK",
      "!EXITVM",
      "!DATALOCATIONS",
      "!NOP",
      "!UNREACHABLE0",
      "!UNREACHABLE1",
      "!PRETENDTOJUMPANYWHERE",
      "exitvm",
      "unreachable",
      "!REPLACEMENT-exitvm/retR",
      "!REPLACEMENT-unreachable/retR"
    };
// #include <stdlib.h>

// #include "izmirvm-specialized-instructions.h"
const size_t
izmirvm_specialized_instruction_residual_arities [IZMIRVM_SPECIALIZED_INSTRUCTION_NO]
  = {
      0, /* !INVALID */
      1, /* !BEGINBASICBLOCK */
      0, /* !EXITVM */
      0, /* !DATALOCATIONS */
      0, /* !NOP */
      0, /* !UNREACHABLE0 */
      0, /* !UNREACHABLE1 */
      0, /* !PRETENDTOJUMPANYWHERE */
      0, /* exitvm */
      0, /* unreachable */
      1, /* !REPLACEMENT-exitvm/retR */
      1 /* !REPLACEMENT-unreachable/retR */
    };
const unsigned long // FIXME: shall I use a shorter type when possible?
izmirvm_specialized_instruction_label_bitmasks [IZMIRVM_SPECIALIZED_INSTRUCTION_NO]
  = {
      /* It's important that !BEGINBASICBLOCK has a zero here: it does not need residual patching. */
      0, /* !INVALID */
      0, /* !BEGINBASICBLOCK */
      0, /* !EXITVM */
      0, /* !DATALOCATIONS */
      0, /* !NOP */
      0, /* !UNREACHABLE0 */
      0, /* !UNREACHABLE1 */
      0, /* !PRETENDTOJUMPANYWHERE */
      0, /* exitvm */
      0, /* unreachable */
      0, /* !REPLACEMENT-exitvm/retR */
      0 /* !REPLACEMENT-unreachable/retR */
    };
#ifdef JITTER_HAVE_PATCH_IN
const unsigned long // FIXME: shall I use a shorter type when possible?
izmirvm_specialized_instruction_fast_label_bitmasks [IZMIRVM_SPECIALIZED_INSTRUCTION_NO]
  = {
      /* It's important that !BEGINBASICBLOCK has a zero here: it does not need residual patching. */
      0, /* !INVALID */
      0, /* !BEGINBASICBLOCK */
      0, /* !EXITVM */
      0, /* !DATALOCATIONS */
      0, /* !NOP */
      0, /* !UNREACHABLE0 */
      0, /* !UNREACHABLE1 */
      0, /* !PRETENDTOJUMPANYWHERE */
      0, /* exitvm */
      0, /* unreachable */
      0, /* !REPLACEMENT-exitvm/retR */
      0 /* !REPLACEMENT-unreachable/retR */
    };
#endif // #ifdef JITTER_HAVE_PATCH_IN

// FIXME: I may want to conditionalize this.
const bool
izmirvm_specialized_instruction_relocatables [IZMIRVM_SPECIALIZED_INSTRUCTION_NO]
  = {
      true, // !INVALID
      true, // !BEGINBASICBLOCK
      true, // !EXITVM
      true, // !DATALOCATIONS
      true, // !NOP
      true, // !UNREACHABLE0
      true, // !UNREACHABLE1
      true, // !PRETENDTOJUMPANYWHERE
      true, // exitvm
      true, // unreachable
      false, // !REPLACEMENT-exitvm/retR
      false // !REPLACEMENT-unreachable/retR
    };

// FIXME: this is not currently accessed, and in fact may be useless.
const bool
izmirvm_specialized_instruction_callers [IZMIRVM_SPECIALIZED_INSTRUCTION_NO]
  = {
      false, // !INVALID
      false, // !BEGINBASICBLOCK
      false, // !EXITVM
      false, // !DATALOCATIONS
      false, // !NOP
      false, // !UNREACHABLE0
      false, // !UNREACHABLE1
      false, // !PRETENDTOJUMPANYWHERE
      false, // exitvm
      false, // unreachable
      false, // !REPLACEMENT-exitvm/retR
      false // !REPLACEMENT-unreachable/retR
    };

// FIXME: this is not currently accessed, and in fact may be useless.
const bool
izmirvm_specialized_instruction_callees [IZMIRVM_SPECIALIZED_INSTRUCTION_NO]
  = {
      false, // !INVALID
      false, // !BEGINBASICBLOCK
      false, // !EXITVM
      false, // !DATALOCATIONS
      false, // !NOP
      false, // !UNREACHABLE0
      false, // !UNREACHABLE1
      false, // !PRETENDTOJUMPANYWHERE
      false, // exitvm
      false, // unreachable
      false, // !REPLACEMENT-exitvm/retR
      false // !REPLACEMENT-unreachable/retR
    };

/* An array whose indices are specialised instruction opcodes, and
   whose elements are the corresponding unspecialised instructions
   opcodes -- or -1 when there is no mapping mapping having */
const int
izmirvm_specialized_instruction_to_unspecialized_instruction
   [IZMIRVM_SPECIALIZED_INSTRUCTION_NO]
  = {
    -1, /* !INVALID */
    -1, /* !BEGINBASICBLOCK */
    -1, /* !EXITVM */
    -1, /* !DATALOCATIONS */
    -1, /* !NOP */
    -1, /* !UNREACHABLE0 */
    -1, /* !UNREACHABLE1 */
    -1, /* !PRETENDTOJUMPANYWHERE */
    izmirvm_meta_instruction_id_exitvm, /* exitvm */
    izmirvm_meta_instruction_id_unreachable, /* unreachable */
    izmirvm_meta_instruction_id_exitvm, /* !REPLACEMENT-exitvm/retR */
    izmirvm_meta_instruction_id_unreachable /* !REPLACEMENT-unreachable/retR */
    };

#ifdef JITTER_HAVE_DEFECT_REPLACEMENT
/* Worst-case replacement table. */
const jitter_uint
izmirvm_worst_case_replacement_table [] =
  {
    izmirvm_specialized_instruction_opcode__eINVALID, /* !INVALID is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__eBEGINBASICBLOCK, /* !BEGINBASICBLOCK is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__eEXITVM, /* !EXITVM is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__eDATALOCATIONS, /* !DATALOCATIONS is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__eNOP, /* !NOP is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__eUNREACHABLE0, /* !UNREACHABLE0 is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__eUNREACHABLE1, /* !UNREACHABLE1 is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__ePRETENDTOJUMPANYWHERE, /* !PRETENDTOJUMPANYWHERE is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__eREPLACEMENT_mexitvm__retR, /* exitvm is POTENTIALLY DEFECTIVE, and replaced by !REPLACEMENT-exitvm/retR. */
    izmirvm_specialized_instruction_opcode__eREPLACEMENT_munreachable__retR, /* unreachable is POTENTIALLY DEFECTIVE, and replaced by !REPLACEMENT-unreachable/retR. */
    izmirvm_specialized_instruction_opcode__eREPLACEMENT_mexitvm__retR, /* !REPLACEMENT-exitvm/retR is NOT potentially defective. */
    izmirvm_specialized_instruction_opcode__eREPLACEMENT_munreachable__retR /* !REPLACEMENT-unreachable/retR is NOT potentially defective. */
  };
#endif // #ifdef JITTER_HAVE_DEFECT_REPLACEMENT


#ifdef JITTER_HAVE_DEFECT_REPLACEMENT
const jitter_uint
izmirvm_call_related_specialized_instruction_ids []
= {

  };

const jitter_uint
izmirvm_call_related_specialized_instruction_id_no
= sizeof (izmirvm_call_related_specialized_instruction_ids) / sizeof (jitter_uint);

const bool
izmirvm_specialized_instruction_call_relateds []
= {
    0, /* !INVALID */
    0, /* !BEGINBASICBLOCK */
    0, /* !EXITVM */
    0, /* !DATALOCATIONS */
    0, /* !NOP */
    0, /* !UNREACHABLE0 */
    0, /* !UNREACHABLE1 */
    0, /* !PRETENDTOJUMPANYWHERE */
    0, /* exitvm */
    0, /* unreachable */
    0, /* !REPLACEMENT-exitvm/retR */
    0 /* !REPLACEMENT-unreachable/retR */
  };

#endif // #ifdef JITTER_HAVE_DEFECT_REPLACEMENT


void
izmirvm_rewrite (struct jitter_mutable_routine *jitter_mutable_routine_p)
{
  JITTTER_REWRITE_FUNCTION_PROLOG_;

/* User-specified code, rewriter part: beginning. */

/* User-specified code, rewriter part: end */


//fprintf (stderr, "No more rules to try\n");
}


//#include <jitter/jitter-fatal.h>

//#include <jitter/jitter.h>
//#include <jitter/jitter-instruction.h>
//#include <jitter/jitter-specialize.h>

//#include "izmirvm-vm.h"
//#include "izmirvm-meta-instructions.h"
//#include "izmirvm-specialized-instructions.h"


/* Recognizer function prototypes. */
inline static enum izmirvm_specialized_instruction_opcode
izmirvm_recognize_specialized_instruction_exitvm (struct jitter_parameter ** const ps,
                                               bool enable_fast_literals)
  __attribute__ ((pure));
inline static enum izmirvm_specialized_instruction_opcode
izmirvm_recognize_specialized_instruction_unreachable (struct jitter_parameter ** const ps,
                                               bool enable_fast_literals)
  __attribute__ ((pure));


/* Recognizer function definitions. */
inline static enum izmirvm_specialized_instruction_opcode
izmirvm_recognize_specialized_instruction_exitvm (struct jitter_parameter ** const ps,
                                               bool enable_fast_literals)
{
  /* The prefix is a full specialized instruction.  We're done recognizing it. */
  return izmirvm_specialized_instruction_opcode_exitvm;
}

inline static enum izmirvm_specialized_instruction_opcode
izmirvm_recognize_specialized_instruction_unreachable (struct jitter_parameter ** const ps,
                                               bool enable_fast_literals)
{
  /* The prefix is a full specialized instruction.  We're done recognizing it. */
  return izmirvm_specialized_instruction_opcode_unreachable;
}



/* Recognizer entry point. */
static enum izmirvm_specialized_instruction_opcode
izmirvm_recognize_specialized_instruction (struct jitter_mutable_routine *p,
                                            const struct jitter_instruction *ins)
{
  bool fl = ! p->options.slow_literals_only;
  const struct jitter_meta_instruction *mi = ins->meta_instruction;
  switch (mi->id)
    {
    case izmirvm_meta_instruction_id_exitvm:
      return izmirvm_recognize_specialized_instruction_exitvm (ins->parameters, fl);
    case izmirvm_meta_instruction_id_unreachable:
      return izmirvm_recognize_specialized_instruction_unreachable (ins->parameters, fl);
    default:
      jitter_fatal ("invalid meta-instruction id %i", (int)mi->id);
    }
  __builtin_unreachable ();
}

/* Specializer entry point: the only non-static function here. */
int
izmirvm_specialize_instruction (struct jitter_mutable_routine *p,
                                 const struct jitter_instruction *ins)
{
  enum izmirvm_specialized_instruction_opcode opcode
    = izmirvm_recognize_specialized_instruction (p, ins);
  if (opcode == izmirvm_specialized_instruction_opcode__eINVALID)
    jitter_fatal ("specialization failed: %s", ins->meta_instruction->name);

#ifdef JITTER_HAVE_DEFECT_REPLACEMENT
  /* Replace the opcode with its non-defective counterpart. */
  opcode = izmirvm_replacement_table [opcode];
#endif // #ifdef JITTER_HAVE_DEFECT_REPLACEMENT

  jitter_add_specialized_instruction_opcode (p, opcode);


  /* FIXME: in the old shell-based generator I grouped specialized instructions by
     their "residual parameter map", yielding a switch with a lot of different
     specialized instructions mapping to the same case.  I should redo that here. */
  switch (opcode)
    {
    /* !INVALID. */
    case izmirvm_specialized_instruction_opcode__eINVALID:
      break;

    /* !BEGINBASICBLOCK. */
    case izmirvm_specialized_instruction_opcode__eBEGINBASICBLOCK:
      /* j:0 residual_no:1 */
      jitter_add_specialized_instruction_literal (p, ins->parameters[0]->literal.ufixnum);
      break;

    /* !EXITVM. */
    case izmirvm_specialized_instruction_opcode__eEXITVM:
      break;

    /* !DATALOCATIONS. */
    case izmirvm_specialized_instruction_opcode__eDATALOCATIONS:
      break;

    /* !NOP. */
    case izmirvm_specialized_instruction_opcode__eNOP:
      break;

    /* !UNREACHABLE0. */
    case izmirvm_specialized_instruction_opcode__eUNREACHABLE0:
      break;

    /* !UNREACHABLE1. */
    case izmirvm_specialized_instruction_opcode__eUNREACHABLE1:
      break;

    /* !PRETENDTOJUMPANYWHERE. */
    case izmirvm_specialized_instruction_opcode__ePRETENDTOJUMPANYWHERE:
      break;

    /* exitvm. */
    case izmirvm_specialized_instruction_opcode_exitvm:
      break;

    /* unreachable. */
    case izmirvm_specialized_instruction_opcode_unreachable:
      break;

    /* !REPLACEMENT-exitvm/retR. */
    case izmirvm_specialized_instruction_opcode__eREPLACEMENT_mexitvm__retR:
      /* j:0 residual_no:1 */
      /* Non-relocatable or callee [[?????FIXME: Do I want this?????]] instruction. 
         Special return-address parameter whose correct value will be patched in at specialization time. */
      jitter_add_specialized_instruction_literal (p, -1);
      break;

    /* !REPLACEMENT-unreachable/retR. */
    case izmirvm_specialized_instruction_opcode__eREPLACEMENT_munreachable__retR:
      /* j:0 residual_no:1 */
      /* Non-relocatable or callee [[?????FIXME: Do I want this?????]] instruction. 
         Special return-address parameter whose correct value will be patched in at specialization time. */
      jitter_add_specialized_instruction_literal (p, -1);
      break;

    default:
      jitter_fatal ("invalid specialized instruction opcode %i", (int)opcode);
    }
  return 1; // FIXME: I should rethink this return value.
}

void
izmirvm_state_initialize_with_slow_registers
   (struct izmirvm_state *jitter_state,
    jitter_uint jitter_slow_register_no_per_class)
{
  struct izmirvm_state_backing * const jitter_state_backing
    __attribute__ ((unused))
    = & jitter_state->izmirvm_state_backing;
  struct izmirvm_state_runtime * const jitter_state_runtime
    __attribute__ ((unused))
    = & jitter_state->_izmirvm_IaSeJMcytQ_state_runtime;

  /* Initialize The Array. */
  jitter_state_backing->jitter_slow_register_no_per_class
    = jitter_slow_register_no_per_class;
  jitter_state_backing->jitter_array
    = jitter_xmalloc (IZMIRVM_ARRAY_SIZE(jitter_state_backing
                         ->jitter_slow_register_no_per_class));

  /* Initialize special-purpose data. */
  izmirvm_initialize_special_purpose_data (IZMIRVM_ARRAY_TO_SPECIAL_PURPOSE_STATE_DATA (jitter_state_backing->jitter_array));

  /* Set the initial program point to an invalid value, for defensiveness. */
  jitter_state_backing->initial_program_point = NULL;

  /* Set the initial exit status. */
  jitter_state_backing->exit_status
    = izmirvm_exit_status_never_executed;

  /* Initialize stack backing and stack runtime data structures, pointing
     to memory from the backings. */

  /* Initialise the link register. */
  jitter_state_runtime->_jitter_link.label = NULL;

  /* Initialise slow registers. */
  izmirvm_initialize_slow_registers
     (jitter_state->izmirvm_state_backing.jitter_array,
      0 /* overwrite any already existing rank */,
      jitter_state_backing->jitter_slow_register_no_per_class);

  /* Link this new state to the list of states. */
  JITTER_LIST_LINK_LAST (izmirvm_state, links, & izmirvm_vm->states, jitter_state);

  /* User code for state initialization. */

  /* End of the user code for state initialization. */

}

void
izmirvm_state_reset
   (struct izmirvm_state *jitter_state)
{
  struct izmirvm_state_backing * const jitter_state_backing
    __attribute__ ((unused))
    = & jitter_state->izmirvm_state_backing;
  struct izmirvm_state_runtime * const jitter_state_runtime
    __attribute__ ((unused))
    = & jitter_state->_izmirvm_IaSeJMcytQ_state_runtime;

  /* No need to touch The Array, which already exists. */
  /* No need to touch special-purpose data, which already exist. */

  /* Set the initial program point to an invalid value, for defensiveness. */
  jitter_state_backing->initial_program_point = NULL;

  /* Set the initial exit status. */
  jitter_state_backing->exit_status
    = izmirvm_exit_status_never_executed;

  /* Initialize stack backing and stack runtime data structures, pointing
     to memory from the backings. */

  /* Initialise the link register. */
  jitter_state_runtime->_jitter_link.label = NULL;

  /* Initialise slow registers. */
  izmirvm_initialize_slow_registers
     (jitter_state->izmirvm_state_backing.jitter_array,
      0 /* overwrite any already existing rank */,
      jitter_state_backing->jitter_slow_register_no_per_class);


  /* No need to touch links within the global list of states:
     this state already exists and is already linked. */

  /* The user supplied no explicit code for state reset: use
     finalisation code followed by initialisation code. */
/* User finalisation. */
{

}
/* User Initialisation. */{

}
  /* End of the user code for state finalisation followed by
     initialisation. */
}

void
izmirvm_state_finalize (struct izmirvm_state *jitter_state)
{
  struct izmirvm_state_backing * const jitter_state_backing
    __attribute__ ((unused))
    = & jitter_state->izmirvm_state_backing;
  struct izmirvm_state_runtime * const jitter_state_runtime
    __attribute__ ((unused))
    = & jitter_state->_izmirvm_IaSeJMcytQ_state_runtime;

  /* User code for state finalization. */

  /* End of the user code for state finalization. */

  /* Finalize stack backings -- There is no need to finalize the stack
     runtime data structures, as they hold no heap data of their own. */


  /* Unlink this state from the list of states. */
  JITTER_LIST_UNLINK (izmirvm_state, links, & izmirvm_vm->states, jitter_state);

  /* Finalize special-purpose data. */
  izmirvm_finalize_special_purpose_data (IZMIRVM_ARRAY_TO_SPECIAL_PURPOSE_STATE_DATA (jitter_state_backing->jitter_array));

  /* Finalize the Array. */
  free ((void *) jitter_state_backing->jitter_array);

}

